package com.sankuai.meituan.banma;

import com.sankuai.meituan.banma.constants.OpenApiConfig;
import com.sankuai.meituan.banma.constants.RequestConstant;
import com.sankuai.meituan.banma.request.EvaluateRequest;
import com.sankuai.meituan.banma.sign.SignHelper;
import com.sankuai.meituan.banma.util.DateUtil;
import com.sankuai.meituan.banma.util.HttpClient;
import com.sankuai.meituan.banma.util.ParamBuilder;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.junit.Test;

import java.util.Map;

public class TestEvaluate {
	private static final Log logger = LogFactory.getLog(TestEvaluate.class);
	// 配送唯一标识，实际实现时需要替换为自己的delivery_id
	private static Long TEST_DELIVERY_ID = 1516949299L;
	//美团配送内部订单id，最长不超过32个字符，实际实现时需要替换为自己的
	private static String MT_PEISONG_ID = "1516949300027436";
	@Test
	public void testEvaluate() throws Exception {
		String appkey = OpenApiConfig.TEST_APP_KEY;
		String secret = OpenApiConfig.TEST_SECRET;

		EvaluateRequest request = buildMockRequest(appkey);

		Map<String, String> params = ParamBuilder.convertToMap(request);
		String sign = SignHelper.generateSign(params, secret);

		params.put("sign", sign);

		try {
			String res = HttpClient.post(RequestConstant.ORDER_EVALUATE, params);
			logger.info(String.format("reponse data: %s", res));
		} catch (Exception e) {
			throw e;
		}
	}

	private EvaluateRequest buildMockRequest(String appkey) {
		EvaluateRequest request = new EvaluateRequest();
		request.setAppkey(appkey);
		request.setTimestamp(DateUtil.unixTime());
		request.setVersion("1.0");

		request.setDeliveryId(TEST_DELIVERY_ID);
		request.setMtPeisongId(MT_PEISONG_ID);
		request.setScore(1);
		request.setCommentContent("小哥神速!");

		return request;
	}

}